'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var utilNpm = require('@pagedip/util-npm');
var resolve = require('@pagedip/util-resolve');
var resolve__default = _interopDefault(resolve);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve$$1, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve$$1(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var npmBinPath = require.resolve("npm/bin/npm-cli.js");

function formatPackageName(pkg) {
  if (typeof pkg !== "string" || !pkg) {
    throw new Error("Expecting non-empty string for package name.");
  }

  if (!resolve.isPath.test(pkg) && pkg.substr(0, 9) !== "@pagedip/") {
    pkg = "@pagedip/" + pkg;
  }

  return pkg;
}

var install = (function () {
  var _ref = _asyncToGenerator(function* (pkgs, opts) {
    if (!Array.isArray(pkgs)) pkgs = pkgs == null ? [] : [pkgs];

    opts = opts || {};
    pkgs = pkgs.map(formatPackageName);

    if (opts.tag) {
      pkgs = pkgs.map(function (p) {
        return p + "@" + opts.tag;
      });
    }

    if (opts.logger) opts.logger.debug("Installing packages '%s'", pkgs);

    var _ref2 = yield utilNpm.npmCommand(["prefix", "-g"], { buffer: true }),
        _ref3 = _slicedToArray(_ref2, 1),
        globalPrefix = _ref3[0];

    yield utilNpm.npmInstall(pkgs.concat("-g"), {
      npmBinPath: npmBinPath,
      env: _extends({}, process.env, {
        PREFIX: globalPrefix.trim()
      })
    });
  });

  function install(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return install;
})();

var _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _asyncToGenerator$1(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve$$1, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve$$1(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var load = (function () {
  var _ref = _asyncToGenerator$1(function* (pkgname, opts) {
    var cliFile = yield resolve__default(pkgname, _extends$1({}, opts, {
      leads: ["@pagedip/", ""],
      packageFilter: function packageFilter(pkg) {
        if (pkg.command) pkg.main = pkg.command;else delete pkg.main;
        return pkg;
      }
    }));

    if (!cliFile) {
      var err = new Error("Could not find package '" + pkgname + "'.");
      err.code = "MODULE_NOT_FOUND";
      throw err;
    }

    return require(cliFile);
  });

  function load(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return load;
})();

exports.install = install;
exports.load = load;
